package org.josast.AX25;

import io.kaitai.struct.ByteBufferKaitaiStream;
import org.josast.AX25.generated.Ax25frames;

public class AX25DecodedData {

  private Ax25frames ax25frames = null;
  public String source;
  private String destination;
  private int PID;
  private int destSSID;
  private int srcSSID;
  private int ctl;

  public AX25DecodedData(byte[] data) {
    ax25frames = new Ax25frames(new ByteBufferKaitaiStream(data));
    source = ax25frames.ax25Frame().ax25Header().srcCallsignRaw().callsignRor().callsign();
    destination = ax25frames.ax25Frame().ax25Header().destCallsignRaw().callsignRor().callsign();
    PID = ax25frames.ax25Frame().pid();
    destSSID = ax25frames.ax25Frame().ax25Header().destSsidRaw().ssid();
    srcSSID = ax25frames.ax25Frame().ax25Header().srcSsidRaw().ssid();
    ctl = ax25frames.ax25Frame().ax25Header().ctl();
  }

  public String toStringHeader() {

    String sep = "\r\n";
    return "Source : "
        + source
        + " - SSID : "
        + srcSSID
        + sep
        + "Destination :"
        + destination
        + " - SSID : "
        + destSSID
        + sep
        + "PID :"
        + PID
        + sep
        + " ctl : "
        + ctl
        + sep;
  }

  public String toStringData() {
    StringBuilder buffer = new StringBuilder();
    byte[] bytes = ax25frames.ax25Frame().ax25Info();
    for (byte b : bytes) {
      buffer.append(String.format("%02X ", b));
    }
    return buffer.toString();
  }
}
